define(["dojo/_base/declare",
        "dojo/_base/lang",
        "dijit/_Widget",
        "dijit/_TemplatedMixin",
        "dijit/_WidgetsInTemplateMixin",
        "dojo/text!./templates/BusyDialog.html",
        "dojo/aspect",
        "dijit/Dialog",
        "dijit/form/Button",
        "dojo/dom-style",
        "dojo/dom-class",
        "dojo/i18n!../nls/user_resources"
        ],
        function(dDeclare,
                dLang,
                dWidget,
                dTemplatedMixin,
                dWidgetsInTemplateMixin,
                templateText,
                dAspect,
                Dialog,
                Button,
                domStyle,
                domClass,
                resources
                ) {
return dDeclare("admin.users.dialogs.BusyDialog", [dWidget,dTemplatedMixin,dWidgetsInTemplateMixin], 
{
    /**
     * @private
     */
    baseClass: "BusyDialog",

      /**
       * The widget template for the dijit._TemplatedMixin base class.
       */
      templateString: templateText,
      
      /** 
       * Indicate if this widget is also a container
       * @private
       */
      isContainer: false,
      
      /**
       * Indicate if there are widgets in the template
       */
      widgetsInTemplate: true,
      
      /**
       * Ok button label
       */
      buttonLabel: resources["closeButtonLabel"],
      
      /**
       * This is a dummy title that should be replaced by the caller
       */
      title: "Title",
      
      message: "",
      
      showCloseButton: true,
      
      /**
       * The startup function
       */
      startup: function() {
          this.inherited(arguments);
          this.closeButton.on("click", dLang.hitch(this, "_hide"));
          if (!this.showCloseButton) {
        	  domStyle.set(this.closeButton.domNode, "visibility", "hidden");
        	  domStyle.set(this.closeButton.domNode, "display", "none");
          }
      },
      
      /**
       * Set the show close button flag
       */
      setCloseButton:function(show) {
    	  console.log("showCloseButton: " + show);
    	  if (!show) {
        	  domStyle.set(this.closeButton.domNode, "visibility", "hidden");
        	  domStyle.set(this.closeButton.domNode, "display", "none");
          }
    	  else {
    		  domStyle.set(this.closeButton.domNode, "visibility", "visible");
        	  domStyle.set(this.closeButton.domNode, "display", "block");
    	  }
      },
      
    /**
     * The postCreate function
     */
    postCreate: function () {
        this.inherited(arguments);
    },
    
    /**
     * Show this dialog
     */
    show:function() {
    	this.dialog.show();
    },
    
    /**
     * Set the message
     */
    setMessage:function(message) {
    	this.messageDiv.innerHTML = message;
    	domClass.replace(this.messageDiv, "busyDialogLoading", "busyDialogError busyDialogMessage");
    },
    
    /**
     * Set the error message
     */
    setErrorMessage:function(message) {
    	this.messageDiv.innerHTML = message;
    	domClass.replace(this.messageDiv, "busyDialogError", "busyDialogLoading busyDialogMessage");
    },
    
    /**
     * Set the success message
     */
    setSuccessMessage:function(message) {
    	this.messageDiv.innerHTML = message;
    	domClass.replace(this.messageDiv, "busyDialogMessage", "busyDialogLoading busyDialogError");
    },
    
    /**
     * Set if this dialog is closable
     */
    setClosable:function(closable) {
    	this.closeButton.set('disabled', !closable);
    	domStyle.set(this.closeButton.domNode, "visibility", "visible");
    	domStyle.set(this.closeButton.domNode, "display", "block");
    },
      
    /**
     * The destroy function
     */
    destroy: function() {
    	this.inherited(arguments);
    },
    
    /**
     * Hide this dialog
     */
    _hide:function() {
    	this.dialog.hide();
    },
    
      /**
       * The cancel button handler
       */
     close:function() {
          this.dialog.destroyRecursive();
          this.destroyRecursive();
     }
});
});
