<%@page pageEncoding="UTF-8"%>
<%@page import="java.util.ResourceBundle" %>
<%@page import="java.util.Locale" %>
<%@page import="java.util.MissingResourceException"%>
<%@page import="java.util.List"%>
<%@page import="java.text.MessageFormat" %>
<%@page import="java.lang.reflect.Method" %>
<%
    Locale currentLocale = request.getLocale();
    //System.out.println("Locale: " + currentLocale.toString());
    String localeStr = currentLocale.getLanguage()+"-" +currentLocale.getCountry().toLowerCase();
    //this attribute is being set by the caller
    String invalidPermission = "";
    String userID="${userID}";
    invalidPermission = getMessage("invalidPermission", currentLocale);
    invalidPermission = MessageFormat.format(invalidPermission, userID);
    String loginTitle = "";
    String path = null;
    //retrieve the previous path - request.getRequestURI will return path of the login.jsp file
    Object prevPath = request.getAttribute("javax.servlet.forward.request_uri");
    if (prevPath != null) {
        path = prevPath.toString();
    }
    else {
        path = request.getHeader("referer");
    }
    String ocmTitle = getMessage("productTitle", currentLocale);
    if (path != null){
        if (path.indexOf("console") != -1) {
            loginTitle = getMessage("managerProductTitle", currentLocale);
        }
        else if (path.indexOf("admin") != -1) {
            loginTitle = ocmTitle;
        }
    }
    if (loginTitle.length() < 15) {
        //title has not translated in the current locale
        loginTitle = getMessage("loginTitle", currentLocale);
    }
%>
<%! 
private String getMessage(String key, Locale locale) {
    //Locale currentLocale = request.getLocale();
    ResourceBundle messages = ResourceBundle.getBundle("com.ibm.nex.dsi.ui.nls.resources", locale);
    String msg = key;
    try {
        msg = messages.getString(key);
    }catch (MissingResourceException e2) {
            String exMsg = "Login E2:Cannot get value for "+key+" in " + locale.toString() +".";
            new Exception(exMsg,e2).printStackTrace();
    }catch (Exception e) {
        String exMsg = "Login E:Cannot get value for "+key+" in " + locale.toString()+".";
        new Exception(exMsg,e).printStackTrace();
    }
    return msg;
}

%>
<!DOCTYPE HTML>
<!-- 
* IBM Confidential
* OCO Source Materials
* 5724-U98, 5655-V48, 5724-U50, 5655-V46
* © Copyright IBM Corp. 2013
* The source code for this program is not published or other -
* wise divested of its trade secrets, irrespective of what has
* been deposited with the U.S. Copyright Office.
*
 -->
<html>
<head>
<title><%=loginTitle%></title>
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/dojo_1.8.1/dojo/resources/dojo.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/dojo_1.8.1/dijit/themes/dijit.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/dojo_1.8.1/dijit/themes/dijit_rtl.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/ibmjs/idx/themes/oneui/idx/widget/commonMessageIcons.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/ibmjs/idx/themes/oneui/oneui.css">
<style type="text/css">
	html, body {
		background-color:#C0C0C0;
		background-image: url('<%=request.getContextPath()%>/images/login_bkgrd.png');
		background-size: cover;
		width: 100%;
		height: 100%;
		margin: 0;
		overflow:hidden;
	}
	
	.pageOverlay {
	    top: 0;
	    left: 0;
	    position: absolute;
	    height: 100%;
	    width: 100%;
	    z-index: 1001;
	    display: block;
	}
	 
	#loadingDiv {
		background-color: #fff;
	    background-image: url('<%=request.getContextPath()%>/dojo/ibmjs/idx/themes/oneui/idx/images/loadingAnimation38px.gif');
	    background-repeat: no-repeat;
	    background-position: center;
	}
	
	.oneui .idxLoginFrameBox {
		width:270px;
	
	    padding:50px 50px;
	
	    border: solid 3px #999999;
	
		-webkit-box-shadow: 0px 0px 3px #000000;
		-moz-box-shadow: 0px 0px 3px #000000;
		box-shadow: 0px 0px 3px #000000;
		
		border-radius: 3px;
	
		background:#ffffff;
	
		margin: 100px auto 0;
	}
	
	.ibmLogo {
		display: block;
		width: 85px;
		height: 30px;
		background-image: url('<%=request.getContextPath()%>/images/ibmLogoDark.png');
		background-repeat: no-repeat;
		margin-bottom: 20px;
	}
</style>
<script>
var dojoConfig = {
    async: true, 
    locale: "<%=localeStr%>",
    has: {
        "dojo-firebug": true,
        "dojo-debug-messages": true
    },
    packages: [
        {name: "idx", location: "../../ibmjs/idx"}
    ]
};
</script>
<script src='<%=request.getContextPath()%>/dojo/dojo_1.8.1/dojo/dojo.js'></script>
<script type="text/javascript">
var invalidPermission = "<%=invalidPermission%>";
require([
	"dojo/parser",
	"dojo/on",
	"dojo/string",
	"dijit/registry",
	"dojo/ready",
	"dijit/layout/ContentPane",
	"idx/layout/BorderContainer",
	"idx/form/TextBox",
	"dijit/form/Button",
	"idx/form/buttons",
	"dojo/domReady!"],
	function(dParser, dom, string, registry, ready) {
	    //alert("hash: " + window.location.hash);
	    var hash = window.location.hash;
	    var user = "";
	    if (hash) {
	        user = hash.substring(1);//skip the hash sign
	        invalidPermission = string.substitute(invalidPermission, {'userID': user});
	    }
	    //remove any fragments
	    window.location.hash = "";
		dParser.parse(); // parse declarative widgets
		preLoader.loadComplete();
		ready(function(){
		    if (user) {
	            populateResultMessage("oneuiMsgError16", invalidPermission, "messageDiv");
	            registry.byId('username').set('value', user);
	        }
		});
		var refreshInterval = 10 * 60 * 1000;//10 minutes
		setTimeout(function(){location.reload();}, refreshInterval);
	}
);

function doSubmission(username, password) {
	var baseURL = window.location.origin;
        var xhrArgs = {
              url: baseURL+"<%=request.getContextPath()%>/j_security_check",
              content: {"j_username":username, "j_password":password},
              handleAs: "text",
              load: handleLoginSuccess,
              error: handleLoginError
        }
        var deferred = dojo.xhrPost(xhrArgs);
}

function handleLoginSuccess (data,ioargs){
    console.log("<%= getMessage("successfulRequestMessage", currentLocale) %>: ");
    //console.log(data);//commenting this because this logs the entire html page from main.jsp
    if (data.indexOf("<login>failed</login>") != -1) {
        //login failed
        populateResultMessage("oneuiMsgError16", "<%= getMessage("loginFailureMessage", currentLocale) %>", "messageDiv");
    }
    else {
        if (data.indexOf("<%=ocmTitle%>") != -1) {
            window.location = "<%=request.getContextPath()%>/admin";
        }
        else {
            window.location = "<%=request.getContextPath()%>/console";
        }
    }
}

function handleLoginError(data,ioargs){
    console.log(data);
    console.log(ioargs);
    if (data.toString().indexOf("403")){
        //user doesn't have the correct role - this login page is no longer valid
        window.location.hash = username.value;
        window.location.reload();
    }
    else {
        console.log("<%= getMessage("loginFailureMessage", currentLocale) %>: ");
        populateResultMessage("oneuiMsgError16", "<%= getMessage("loginFailureMessage", currentLocale) %>", "messageDiv");
    }
}

function handleLogin() {
	var username;
	var password;
	require(["dojo/dom"], function(dom){
		username = dom.byId("username").value;
		password = dom.byId("password").value;
	});
	if (!username || !password) {
		populateResultMessage("oneuiMsgError16", "<%= getMessage("loginMandatoryMessage", currentLocale) %>", "messageDiv");
	} else {
		doSubmission(username, password);
	}
}

function populateResultMessage(imgClass, msg, div) {
	var result = formatResultTable(imgClass, msg);
	require(["dojo/dom"], function(dom){
		dom.byId(div).innerHTML = result;
	});
}

function displayProductName(){
	require(["dojo/dom"], function(dom){
		var path = window.location.pathname;
		dom.byId("productTitleDisplayPrefix").innerHTML = "<%= getMessage("productTitlePrefix", currentLocale) %>";
		if ((path.indexOf("admin"))!= -1){
			dom.byId("productTitleDisplay").innerHTML = "<%= getMessage("ocmProductTitleSuffix", currentLocale) %>";
		}else{
			dom.byId("productTitleDisplay").innerHTML = "<%= getMessage("managerProductTitleSuffix", currentLocale) %>";
		}			          				
		});
}

function formatResultTable(imgClass, msg) {
	var resultTable = "<table style='border-style:none'><tr><td><div class='" + imgClass + "' /></td><td style='padding-left:5px'>" + msg + "</td></tr></table>"; 
	return resultTable; 
}

function handleCancel() {
	window.location = "<%=request.getContextPath()%>/admin/main.jsp";
}

function preLoad() {
	if (window.location.search) {
		populateResultMessage("oneuiMsgError16", "<%= getMessage("loginFailureMessage", currentLocale) %>", "messageDiv");
	}
	displayProductName();
}

function isEnter(event) {
	if (event.keyCode == 13) {
		handleLogin();
	}
}

</script>
    
</head>
<body class="oneui" onload="preLoad()">
	<div id="loadingDiv" class="loadingDiv pageOverlay"></div>
	<script>
		var preLoader;
		require(["dojo/_base/declare", 
		         "dojo/_base/fx", 
		         "dojo/dom", 
		         "dojo/dom-style"],
		function(declare, fx, dom, domStyle){
			var PreLoader = declare(null, {
				loadingNode: null,
				constructor: function(){
					this.loadingNode = dom.byId('loadingDiv');
				},
				loadComplete: function(){
					fx.fadeOut({
						node: this.loadingNode,
						onEnd: function(node){
							domStyle.set(node, 'display', 'none');
						}
					}).play();
				}
			});
			preLoader = new PreLoader();
		});
	</script>
	<div dojoType="idx.layout.BorderContainer" style="width: 100%; height: 100%;" gutters="false">
		<div dojoType="dijit.layout.ContentPane" region="center">
			<div class="idxLoginFrame">
			    <div class="idxLoginFrameBoxWithShadow">
			      <div class="idxLoginFrameBox">
			       <div class="idxLoginFrameBoxInner">
			          <div class="ibmLogo"></div>
			          <div class="idxLoginFrameTitle" style="margin-bottom:20px">
			          	<span id="productTitleDisplayPrefix"></span>
			          	<br/>
			          	<span id="productTitleDisplay"></span>
			          </div>
			          <div id="username" data-dojo-type="idx.form.TextBox" data-dojo-props='onKeyUp:isEnter, required: false' placeholder="<%= getMessage("userNameHint", currentLocale) %>"
			             style="margin-bottom:20px;"></div>
			          <div id="password" data-dojo-type="idx.form.TextBox" type="password" data-dojo-props='onKeyUp:isEnter, required: false' style="margin-bottom:15px;" placeholder="<%= getMessage("passwordHint", currentLocale) %>"></div>
			          <div id="messageDiv"></div>
			          <div data-dojo-type="idx/layout/ButtonBar" style="margin-bottom:30px; margin-top:15px;">
							<div id="submitButton" data-dojo-type="dijit/form/Button" placement="special" data-dojo-props="onClick:handleLogin"><%= getMessage("loginButtonLabel", currentLocale) %></div>
							<div id="cancelButton" data-dojo-type="dijit/form/Button" placement="secondary" data-dojo-props="onClick:handleCancel"><%= getMessage("cancelButtonLabel", currentLocale) %></div>
	  				  </div>
			          <div data-dojo-attach-point="copyrightNode" class="legal"><%= getMessage("copyright", currentLocale) %></div>
			       </div>
			      </div>
			    </div>
			</div>
		</div>
	</div>
</body>
</html>
